tinsert(CT_RABoss_ModsToLoad, "CT_RABossSarf_Firelord_OnLoad");

function CT_RABossSarf_Firelord_OnLoad()
	CT_RABoss_AddMod(CT_RABOSS_FIRELORD_NAME, CT_RABOSS_FIRELORD_INFO, nil, CT_RABOSS_LOCATIONS_MOLTENCORE);
	
	CT_RABoss_AddEvent(CT_RABOSS_FIRELORD_NAME, "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF", CT_RABossSarf_Firelord_EventHandler);
	
	CT_RABoss_AddDropDownButton(CT_RABOSS_FIRELORD_NAME, { CT_RABOSS_FIRELORD_ALERT_LAVASPAWN, CT_RABOSS_FIRELORD_ALERT_LAVASPAWN_LAVASPAWN_INFO }, "CT_RABoss_ModInfo", "alertLavaSpawn", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton(CT_RABOSS_FIRELORD_NAME, { CT_RABOSS_FIRELORD_TARGET_LAVASPAWN, CT_RABOSS_FIRELORD_TARGET_LAVASPAWN_INFO }, "CT_RABoss_ModInfo", "targetLavaSpawn", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton(CT_RABOSS_FIRELORD_NAME, { CT_RABOSS_FIRELORD_ANNOUNCE_LAVASPAWN, CT_RABOSS_FIRELORD_ANNOUNCE_LAVASPAWN_INFO }, "CT_RABoss_ModInfo", "announceRaidLavaSpawn", "CT_RABoss_SetInfo");
end


function CT_RABossSarf_Firelord_LavaSpawn_Target()
	local targetName = UnitName("target");
	if ( UnitExists("target") ) then
		if ( targetName == CT_RABOSS_FIRELORD_NAME_LAVASPAWN ) and ( not UnitIsCorpse("target") ) then
			return;
		end
		local isMainTank = false;
		for k, v in CT_RATarget.MainTanks do
			if ( UnitIsUnit("raid" .. ( v[1] or "" ), "player") ) then
				isMainTank = true;
				break;
			end
		end
		if ( isMainTank ) and ( targetName == CT_RABOSS_FIRELORD_NAME ) and ( not UnitIsCorpse("target") ) then
			return;
		end
	end
	TargetByName(CT_RABOSS_FIRELORD_NAME_LAVASPAWN);
end

function CT_RABossSarf_Firelord_EventHandler(event)
	local firelordOptions = CT_RABoss_Mods[CT_RABOSS_FIRELORD_NAME];
	if ( not firelordOptions or not firelordOptions["status"] or not firelordOptions.enabled ) then
		return;
	end
	if ( arg1 == CT_RABOSS_FIRELORD_SPELL_LAVASPAWN ) then
		if ( firelordOptions["announceRaidLavaSpawn"] ) or ( firelordOptions["alertLavaSpawn"] ) then
			CT_RABoss_Announce(CT_RABOSS_FIRELORD_MSG_SPAWN, firelordOptions["announceRaidLavaSpawn"]);
			CT_RABoss_PlaySound(3);
		end
		if ( firelordOptions["targetLavaSpawn"] ) then
			CT_RABoss_Schedule("CT_RABossSarf_Firelord_LavaSpawn_Target", 1);
		end
	end
end
